Index: /java/main/src/main/java/com/framsticks/communication/ClientSideManagedConnection.java
===================================================================
--- /java/main/src/main/java/com/framsticks/communication/ClientSideManagedConnection.java	(revision 106)
+++ /java/main/src/main/java/com/framsticks/communication/ClientSideManagedConnection.java	(revision 107)
@@ -80,5 +80,5 @@
 		protocolVersion = -1;
 		requestedFeatures.add("request_id");
-		requestedFeatures.add("call_empty_result");
+		// requestedFeatures.add("call_empty_result");
 		requestedFeatures.add("needfile_id");
 	}
Index: /java/main/src/main/java/com/framsticks/communication/ServerSideManagedConnection.java
===================================================================
--- /java/main/src/main/java/com/framsticks/communication/ServerSideManagedConnection.java	(revision 106)
+++ /java/main/src/main/java/com/framsticks/communication/ServerSideManagedConnection.java	(revision 107)
@@ -56,8 +56,8 @@
 					return;
 				}
-				if (feature.equals("call_empty_result")) {
-					responseCallback.pass(new Response(true, null));
-					return;
-				}
+				// if (feature.equals("call_empty_result")) {
+				// 	responseCallback.pass(new Response(true, null));
+				// 	return;
+				// }
 				if (feature.equals("needfile_id")) {
 					responseCallback.pass(new Response(true, null));
Index: /java/main/src/main/java/com/framsticks/experiment/AbstractExperimentLogic.java
===================================================================
--- /java/main/src/main/java/com/framsticks/experiment/AbstractExperimentLogic.java	(revision 106)
+++ /java/main/src/main/java/com/framsticks/experiment/AbstractExperimentLogic.java	(revision 107)
@@ -15,4 +15,5 @@
 	 * @return the experiment
 	 */
+	@Override
 	public Experiment getExperiment() {
 		return experiment;
Index: /java/main/src/main/java/com/framsticks/experiment/Experiment.java
===================================================================
--- /java/main/src/main/java/com/framsticks/experiment/Experiment.java	(revision 106)
+++ /java/main/src/main/java/com/framsticks/experiment/Experiment.java	(revision 107)
@@ -1,4 +1,6 @@
 package com.framsticks.experiment;
 
+import java.util.LinkedList;
+import java.util.List;
 import java.util.Map;
 
@@ -8,4 +10,5 @@
 
 import com.framsticks.params.EventListener;
+import com.framsticks.params.MessageLogger;
 import com.framsticks.params.ParamFlags;
 import com.framsticks.params.SimpleUniqueList;
@@ -13,7 +16,8 @@
 import com.framsticks.params.annotations.FramsClassAnnotation;
 import com.framsticks.params.annotations.ParamAnnotation;
-import com.framsticks.params.types.ProcedureParam;
 import com.framsticks.remote.RemoteTree;
+import com.framsticks.structure.Path;
 import com.framsticks.structure.messages.ListChange;
+import com.framsticks.structure.messages.Message;
 import com.framsticks.util.ExceptionHandler;
 import com.framsticks.util.FramsticksException;
@@ -23,4 +27,6 @@
 import com.framsticks.util.dispatching.DispatcherSetable;
 import com.framsticks.util.dispatching.Dispatching;
+import com.framsticks.util.dispatching.Future;
+import com.framsticks.util.dispatching.FutureHandler;
 import com.framsticks.util.dispatching.Joinable;
 import com.framsticks.util.dispatching.JoinableCollection;
@@ -43,6 +49,9 @@
 	protected final BufferedDispatcher<Experiment> bufferedDispatcher = new BufferedDispatcher<>(this);
 
+	protected SimulatorProvider simulatorProvider;
+
 	protected String expdef;
 
+	protected final MessageLogger messages = new MessageLogger(NetLoadSaveLogic.class);
 
 	/**
@@ -90,4 +99,21 @@
 
 	/**
+	 * @return the simulatorProvider
+	 */
+	@ParamAnnotation(flags = ParamFlags.USERREADONLY)
+	public SimulatorProvider getSimulatorProvider() {
+		return simulatorProvider;
+	}
+
+	/**
+	 * @param simulatorProvider the simulatorProvider to set
+	 */
+	@AutoAppendAnnotation
+	@ParamAnnotation
+	public void setSimulatorProvider(SimulatorProvider simulatorProvider) {
+		this.simulatorProvider = simulatorProvider;
+	}
+
+	/**
 	 * @return the expdef
 	 */
@@ -118,8 +144,10 @@
 	@AutoAppendAnnotation
 	public void addSimulator(Simulator simulator) {
+		log.debug("add simulator {}", simulator);
 		simulators.add(simulator);
 		simulatorAsJoinables.add(simulator);
 		simulators.fireChildrenChange(simulator, ListChange.Action.Modify, "ready");
 
+		simulatorCandidates.remove(simulator.getRemoteTree());
 	}
 
@@ -156,5 +184,8 @@
 
 		Dispatching.use(simulatorAsJoinables, this);
+		Dispatching.use(simulatorProvider, this);
 		Dispatching.use(simulatorCandidates, this);
+
+		tryProvideAllSimulators(Future.<List<Simulator>>doNothing(this));
 	}
 
@@ -163,5 +194,8 @@
 
 		Dispatching.drop(simulatorAsJoinables, this);
+		Dispatching.drop(simulatorProvider, this);
 		Dispatching.drop(simulatorCandidates, this);
+
+		Dispatching.drop(bufferedDispatcher, this);
 
 		finishJoinable();
@@ -175,9 +209,9 @@
 	@Override
 	protected void joinableJoin() throws InterruptedException {
-		Dispatching.drop(bufferedDispatcher, this);
 
 		Dispatching.join(simulatorAsJoinables);
+		Dispatching.join(simulatorProvider);
 		Dispatching.join(simulatorCandidates);
-		Dispatching.join(bufferedDispatcher.getTargetDispatcher());
+		// Dispatching.join(bufferedDispatcher.getTargetDispatcher());
 	}
 
@@ -197,9 +231,62 @@
 	}
 
-	@ParamAnnotation(paramType = ProcedureParam.class)
-	public void connectToSimulator(String address) {
-		SimulatorConnector connector = new SimulatorConnector();
-		connector.setAddress(address);
-		connector.attachTo(this);
+	// @ParamAnnotation(paramType = ProcedureParam.class)
+	// public void connectToSimulator(String address) {
+	//	SimulatorConnector connector = new SimulatorConnector();
+	//	connector.setAddress(address);
+	//	connector.attachTo(this);
+	// }
+	//
+
+	public Simulator createSimulator(RemoteTree tree, Path path) {
+		return new Simulator(this, tree, path);
+	}
+
+	public void tryProvideNextSimulator(final FutureHandler<Simulator> future) {
+		log.debug("trying to provide next simulator");
+		simulatorProvider.provideSimulator(new SimulatorSpecification(this, expdef), new Future<Simulator>(future) {
+
+			@Override
+			protected void result(Simulator result) {
+				assert isActive();
+				if (result != null) {
+					addSimulator(result);
+				} else {
+					log.debug("no more simulators remaining");
+				}
+				future.pass(result);
+
+			}
+		});
+
+	}
+
+	public void tryProvideAllSimulators(final FutureHandler<List<Simulator>> future) {
+		log.debug("trying to provide all simulators");
+		final List<Simulator> list = new LinkedList<>();
+
+		tryProvideNextSimulator(new Future<Simulator>(future) {
+
+			@Override
+			protected void result(Simulator result) {
+				if (result == null) {
+					future.pass(list);
+					return;
+				}
+				list.add(result);
+				tryProvideNextSimulator(this);
+			}
+		});
+
+	}
+
+	@ParamAnnotation(id = "messages")
+	public void addMessageListener(EventListener<Message> listener) {
+		messages.add(listener);
+	}
+
+	@ParamAnnotation(id = "messages")
+	public void removeMessageListener(EventListener<Message> listener) {
+		messages.remove(listener);
 	}
 
Index: /java/main/src/main/java/com/framsticks/experiment/ExperimentLogic.java
===================================================================
--- /java/main/src/main/java/com/framsticks/experiment/ExperimentLogic.java	(revision 106)
+++ /java/main/src/main/java/com/framsticks/experiment/ExperimentLogic.java	(revision 107)
@@ -3,3 +3,5 @@
 public interface ExperimentLogic {
 
+	public Experiment getExperiment();
+
 }
Index: /java/main/src/main/java/com/framsticks/experiment/NetLoadSaveLogic.java
===================================================================
--- /java/main/src/main/java/com/framsticks/experiment/NetLoadSaveLogic.java	(revision 106)
+++ /java/main/src/main/java/com/framsticks/experiment/NetLoadSaveLogic.java	(revision 107)
@@ -18,5 +18,4 @@
 	private static final Logger log = LogManager.getLogger(NetLoadSaveLogic.class);
 
-	protected String option = "an option";
 
 	protected final Class<NF> netJavaClass;
@@ -95,20 +94,4 @@
 
 	/**
-	 * @return the option
-	 */
-	@ParamAnnotation
-	public String getOption() {
-		return option;
-	}
-
-	/**
-	 * @param option the option to set
-	 */
-	@ParamAnnotation
-	public void setOption(String option) {
-		this.option = option;
-	}
-
-	/**
 	 * @return the netJavaClass
 	 */
Index: /java/main/src/main/java/com/framsticks/experiment/Simulator.java
===================================================================
--- /java/main/src/main/java/com/framsticks/experiment/Simulator.java	(revision 106)
+++ /java/main/src/main/java/com/framsticks/experiment/Simulator.java	(revision 107)
@@ -157,4 +157,6 @@
 	@ParamAnnotation(paramType = ProcedureParam.class)
 	public void init() {
+		log.debug("initializing simulator {}", this);
+		call(simulatorPath, "init", arguments(), Object.class, Future.doNothing(Object.class, this));
 	}
 
@@ -168,4 +170,5 @@
 	public void stop() {
 		log.debug("stoping simulator {}", this);
+		call(simulatorPath, "stop", arguments(), Object.class, Future.doNothing(Object.class, this));
 	}
 
@@ -202,5 +205,5 @@
 
 	public <N> void netload(final N net, final FutureHandler<Object> future) {
-		final String netloadId = "NetLoadSaveLogic" + netloadIdCounter.getAndIncrement();
+		final String netloadId = "netload" + netloadIdCounter.getAndIncrement();
 
 		final File file = AccessOperations.convert(File.class, net, getRemoteTree().getRegistry());
Index: /java/main/src/main/java/com/framsticks/experiment/SimulatorConnector.java
===================================================================
--- /java/main/src/main/java/com/framsticks/experiment/SimulatorConnector.java	(revision 106)
+++ /java/main/src/main/java/com/framsticks/experiment/SimulatorConnector.java	(revision 107)
@@ -7,30 +7,75 @@
 import com.framsticks.communication.Address;
 import com.framsticks.params.annotations.FramsClassAnnotation;
-import com.framsticks.params.annotations.ParamAnnotation;
 import com.framsticks.remote.RemoteTree;
 import com.framsticks.structure.Path;
-import com.framsticks.util.AutoAttacher;
 import com.framsticks.util.Misc;
 import com.framsticks.util.dispatching.Dispatcher;
 import com.framsticks.util.dispatching.Dispatching;
 import com.framsticks.util.dispatching.Future;
-import com.framsticks.util.lang.Casting;
-import com.framsticks.util.lang.Strings;
+import com.framsticks.util.dispatching.FutureHandler;
+import com.framsticks.util.dispatching.Joinable;
+import com.framsticks.util.dispatching.JoinableParent;
+import com.framsticks.util.dispatching.JoinableState;
 
 import static com.framsticks.structure.TreeOperations.*;
 
 @FramsClassAnnotation
-public class SimulatorConnector implements AutoAttacher {
+public class SimulatorConnector extends SingleSimulatorProvider implements JoinableParent {
 	private static final Logger log = LogManager.getLogger(SimulatorConnector.class);
 
+	protected Experiment experiment;
+	protected RemoteTree remoteTree;
+	protected Simulator simulator;
+	protected Address address;
+	protected boolean provided = false;
 
-	protected Experiment experiment;
-	protected Address address;
-	protected RemoteTree remoteTree;
+	public boolean hasProvided() {
+		return provided;
+	}
+
+	public void setAddress(Address address) {
+		this.address = address;
+	}
+
+	public Address getAddress() {
+		return address;
+	}
+
+
+	@Override
+	public String getName() {
+		return "simulator connector";
+	}
+
+	@Override
+	protected void joinableStart() {
+
+	}
+
+	@Override
+	protected void joinableInterrupt() {
+		Dispatching.drop(remoteTree, this);
+		finishJoinable();
+	}
+
+	@Override
+	protected void joinableFinish() {
+
+	}
+
+	@Override
+	protected void joinableJoin() throws InterruptedException {
+		Dispatching.join(remoteTree);
+	}
 
 	@SuppressWarnings({ "rawtypes", "unchecked" })
 	@Override
-	public void attachTo(Object parent) {
-		experiment = Casting.throwCast(Experiment.class, parent);
+	public void provideSimulator(final SimulatorSpecification specification, final FutureHandler<Simulator> future) {
+		if (hasProvided()) {
+			future.pass(null);
+			return;
+		}
+		provided = true;
+		experiment = specification.getExperiment();
 
 		Misc.throwIfNull(address);
@@ -41,6 +86,6 @@
 		remoteTree.setDispatcher((Dispatcher) experiment.getDispatcher());
 
-
 		experiment.getSimulatorCandidates().add(remoteTree);
+		Dispatching.use(remoteTree, this);
 
 		Dispatching.dispatchLog(remoteTree, log, Level.DEBUG, "first task in remote tree");
@@ -51,27 +96,16 @@
 			protected void result(Path result) {
 				log.debug("resolved simulator path: {}", result);
-				Misc.checkEquals(experiment.getExpdef(), bindAccess(result).get("expdef", String.class), "expdef mismatch in connected simulator", this);
+				Misc.checkEquals(specification.getDefinition(), bindAccess(result).get("expdef", String.class), "expdef mismatch in connected simulator", SimulatorConnector.this);
 
-				Simulator simulator = new Simulator(experiment, remoteTree, result);
-				experiment.addSimulator(simulator);
-				experiment.getSimulatorCandidates().remove(remoteTree);
+				simulator = experiment.createSimulator(remoteTree, result);
+
+				future.pass(simulator);
 			}
 		});
 	}
 
-	@ParamAnnotation
-	public void setAddress(String address) {
-		this.address = new Address(address);
+	@Override
+	public void childChangedState(Joinable joinable, JoinableState state) {
+		log.debug("child {} changed state to {}", joinable, state);
 	}
-
-	@ParamAnnotation
-	public String getAddress() {
-		return Strings.toStringNullProof(address, "");
-	}
-
-	@Override
-	public String toString() {
-		return "simulator connector to: " + Strings.toStringNullProof(address, "<null>");
-	}
-
 }
Index: /java/main/src/main/java/com/framsticks/experiment/SimulatorGroup.java
===================================================================
--- /java/main/src/main/java/com/framsticks/experiment/SimulatorGroup.java	(revision 107)
+++ /java/main/src/main/java/com/framsticks/experiment/SimulatorGroup.java	(revision 107)
@@ -0,0 +1,42 @@
+package com.framsticks.experiment;
+
+import java.util.Iterator;
+
+import com.framsticks.params.annotations.FramsClassAnnotation;
+import com.framsticks.util.dispatching.Future;
+import com.framsticks.util.dispatching.FutureHandler;
+import com.framsticks.util.dispatching.JoinableCollection;
+
+@FramsClassAnnotation
+public class SimulatorGroup extends JoinableCollection<SimulatorProvider> implements SimulatorProvider {
+
+	@Override
+	public String getName() {
+		return "simulator group";
+	}
+
+
+	@Override
+	public void provideSimulator(final SimulatorSpecification specification, final FutureHandler<Simulator> future) {
+		final Iterator<SimulatorProvider> iterator = joinables.iterator();
+
+		new Future<Simulator>(future) {
+
+			@Override
+			protected void result(Simulator result) {
+				if (result != null) {
+					future.pass(result);
+					return;
+				}
+				if (!iterator.hasNext()) {
+					future.pass(null);
+					return;
+				}
+				iterator.next().provideSimulator(specification, this);
+
+			}
+		}.pass(null);
+
+	}
+
+}
Index: /java/main/src/main/java/com/framsticks/experiment/SimulatorProvider.java
===================================================================
--- /java/main/src/main/java/com/framsticks/experiment/SimulatorProvider.java	(revision 107)
+++ /java/main/src/main/java/com/framsticks/experiment/SimulatorProvider.java	(revision 107)
@@ -0,0 +1,11 @@
+package com.framsticks.experiment;
+
+import com.framsticks.params.annotations.FramsClassAnnotation;
+import com.framsticks.util.dispatching.FutureHandler;
+import com.framsticks.util.dispatching.Joinable;
+
+@FramsClassAnnotation
+public interface SimulatorProvider extends Joinable {
+
+	public void provideSimulator(SimulatorSpecification specification, FutureHandler<Simulator> future);
+}
Index: /java/main/src/main/java/com/framsticks/experiment/SimulatorRange.java
===================================================================
--- /java/main/src/main/java/com/framsticks/experiment/SimulatorRange.java	(revision 107)
+++ /java/main/src/main/java/com/framsticks/experiment/SimulatorRange.java	(revision 107)
@@ -0,0 +1,105 @@
+package com.framsticks.experiment;
+
+import java.util.ArrayList;
+import java.util.Iterator;
+import java.util.List;
+
+import org.apache.logging.log4j.Logger;
+import org.apache.logging.log4j.LogManager;
+
+import com.framsticks.communication.Address;
+import com.framsticks.params.annotations.FramsClassAnnotation;
+import com.framsticks.params.annotations.ParamAnnotation;
+import com.framsticks.params.types.UniversalParam;
+import com.framsticks.util.dispatching.FutureHandler;
+import com.framsticks.util.dispatching.JoinableCollection;
+
+@FramsClassAnnotation
+public class SimulatorRange extends JoinableCollection<SimulatorProvider> implements SimulatorProvider {
+	private static final Logger log = LogManager.getLogger(Experiment.class);
+
+
+	protected List<String> hosts = new ArrayList<>();
+	protected List<Integer> ports = new ArrayList<>();
+
+	protected Iterator<Address> addresses;
+	protected boolean run = true;
+
+	@Override
+	public String getName() {
+		return "simulator range";
+	}
+
+	@Override
+	public void provideSimulator(final SimulatorSpecification specification, final FutureHandler<Simulator> future) {
+		if (addresses == null) {
+			log.info("providing simulators from set: {} X {}", hosts, ports);
+
+			List<Address> list = new ArrayList<Address>();
+			for (String host : hosts) {
+				for (Integer port : ports) {
+					list.add(new Address(host, port));
+				}
+			}
+			addresses = list.iterator();
+		}
+
+		if (!addresses.hasNext()) {
+			future.pass(null);
+			return;
+		}
+		Address address = addresses.next();
+		SingleSimulatorProvider provider = (run ? new SimulatorRunner() : new SimulatorConnector());
+		provider.setAddress(address);
+		add(provider);
+		provider.provideSimulator(specification, future);
+	}
+
+	/**
+	 * @return the hosts
+	 */
+	@ParamAnnotation(paramType = UniversalParam.class)
+	public List<String> getHosts() {
+		return hosts;
+	}
+
+	/**
+	 * @param hosts the hosts to set
+	 */
+	@ParamAnnotation
+	public void setHosts(List<String> hosts) {
+		this.hosts = hosts;
+	}
+
+	/**
+	 * @return the ports
+	 */
+	@ParamAnnotation(paramType = UniversalParam.class)
+	public List<Integer> getPorts() {
+		return ports;
+	}
+
+	/**
+	 * @param ports the ports to set
+	 */
+	@ParamAnnotation
+	public void setPorts(List<Integer> ports) {
+		this.ports = ports;
+	}
+
+	/**
+	 * @return the run
+	 */
+	@ParamAnnotation
+	public boolean getRun() {
+		return run;
+	}
+
+	/**
+	 * @param run the run to set
+	 */
+	@ParamAnnotation
+	public void setRun(boolean run) {
+		this.run = run;
+	}
+}
Index: /java/main/src/main/java/com/framsticks/experiment/SimulatorRunner.java
===================================================================
--- /java/main/src/main/java/com/framsticks/experiment/SimulatorRunner.java	(revision 107)
+++ /java/main/src/main/java/com/framsticks/experiment/SimulatorRunner.java	(revision 107)
@@ -0,0 +1,92 @@
+package com.framsticks.experiment;
+
+import org.apache.logging.log4j.Logger;
+import org.apache.logging.log4j.LogManager;
+
+import com.framsticks.communication.Address;
+import com.framsticks.params.annotations.FramsClassAnnotation;
+import com.framsticks.running.FramsServer;
+import com.framsticks.util.dispatching.Dispatching;
+import com.framsticks.util.dispatching.FutureHandler;
+import com.framsticks.util.dispatching.Joinable;
+import com.framsticks.util.dispatching.JoinableParent;
+import com.framsticks.util.dispatching.JoinableState;
+
+@FramsClassAnnotation
+public class SimulatorRunner extends SingleSimulatorProvider implements JoinableParent {
+
+	private static final Logger log = LogManager.getLogger(SimulatorRunner.class);
+
+	protected final SimulatorConnector connector;
+	protected final FramsServer server;
+
+	/**
+	 *
+	 */
+	public SimulatorRunner() {
+		connector = new SimulatorConnector();
+		server = new FramsServer();
+	}
+
+	@Override
+	public String getName() {
+		return "simulator runner";
+	}
+
+	@Override
+	public void provideSimulator(SimulatorSpecification specification, FutureHandler<Simulator> future) {
+		if (connector.hasProvided()) {
+			future.pass(null);
+			return;
+		}
+		log.debug("running simulator at {}", getAddress());
+
+		if (!getAddress().getHostName().equals("localhost")) {
+			server.setHost(getAddress().getHostName());
+		}
+
+		server.setPort(getAddress().getPort());
+		server.setExpdef(specification.getDefinition());
+
+		Dispatching.use(server, this);
+
+		Dispatching.use(connector, this);
+		connector.provideSimulator(specification, future);
+	}
+
+	@Override
+	public void childChangedState(Joinable joinable, JoinableState state) {
+		proceedToState(state);
+	}
+
+	@Override
+	protected void joinableStart() {
+	}
+
+	@Override
+	protected void joinableInterrupt() {
+		finishJoinable();
+	}
+
+	@Override
+	protected void joinableFinish() {
+		Dispatching.drop(connector, this);
+		Dispatching.drop(server, this);
+	}
+
+	@Override
+	protected void joinableJoin() throws InterruptedException {
+		Dispatching.join(connector);
+		Dispatching.join(server);
+	}
+
+	@Override
+	public Address getAddress() {
+		return connector.getAddress();
+	}
+
+	@Override
+	public void setAddress(Address address) {
+		connector.setAddress(address);
+	}
+}
Index: /java/main/src/main/java/com/framsticks/experiment/SimulatorSpecification.java
===================================================================
--- /java/main/src/main/java/com/framsticks/experiment/SimulatorSpecification.java	(revision 107)
+++ /java/main/src/main/java/com/framsticks/experiment/SimulatorSpecification.java	(revision 107)
@@ -0,0 +1,31 @@
+package com.framsticks.experiment;
+
+public class SimulatorSpecification {
+
+	protected final Experiment experiment;
+	protected final String definition;
+
+	/**
+	 * @param experiment
+	 * @param definition
+	 */
+	public SimulatorSpecification(Experiment experiment, String definition) {
+		this.experiment = experiment;
+		this.definition = definition;
+	}
+
+	/**
+	 * @return the experiment
+	 */
+	public Experiment getExperiment() {
+		return experiment;
+	}
+
+	/**
+	 * @return the definition
+	 */
+	public String getDefinition() {
+		return definition;
+	}
+
+}
Index: /java/main/src/main/java/com/framsticks/experiment/SingleSimulatorProvider.java
===================================================================
--- /java/main/src/main/java/com/framsticks/experiment/SingleSimulatorProvider.java	(revision 107)
+++ /java/main/src/main/java/com/framsticks/experiment/SingleSimulatorProvider.java	(revision 107)
@@ -0,0 +1,30 @@
+package com.framsticks.experiment;
+
+import com.framsticks.communication.Address;
+import com.framsticks.params.annotations.ParamAnnotation;
+import com.framsticks.util.dispatching.AbstractJoinable;
+import com.framsticks.util.lang.Strings;
+
+public abstract class SingleSimulatorProvider extends AbstractJoinable implements SimulatorProvider {
+
+
+	@ParamAnnotation(id = "address")
+	public void setAddressString(String address) {
+		setAddress(new Address(address));
+	}
+
+	@ParamAnnotation(id = "address")
+	public String getAddressString() {
+		return Strings.toStringNullProof(getAddress(), "");
+	}
+
+	public abstract void setAddress(Address address);
+
+	public abstract Address getAddress();
+
+	@Override
+	public String toString() {
+		return "simulator connector to: " + Strings.toStringNullProof(getAddress(), "<null>");
+	}
+
+}
Index: /java/main/src/main/java/com/framsticks/experiment/WorkPackageLogic.java
===================================================================
--- /java/main/src/main/java/com/framsticks/experiment/WorkPackageLogic.java	(revision 106)
+++ /java/main/src/main/java/com/framsticks/experiment/WorkPackageLogic.java	(revision 107)
@@ -76,5 +76,5 @@
 				assert experiment.isActive();
 
-				log.debug("received package from {}: {}", simulator, netResult);
+				log.info("received package from {}: {}", simulator, netResult);
 				WorkPackageLogic.this.messages.info("netsave", netResult.toString());
 
Index: /java/main/src/main/java/com/framsticks/gui/controls/TextAreaControl.java
===================================================================
--- /java/main/src/main/java/com/framsticks/gui/controls/TextAreaControl.java	(revision 106)
+++ /java/main/src/main/java/com/framsticks/gui/controls/TextAreaControl.java	(revision 107)
@@ -5,8 +5,10 @@
 
 import javax.swing.*;
+import javax.swing.text.JTextComponent;
+
 import java.awt.*;
 
 @SuppressWarnings("serial")
-public class TextAreaControl extends TextControl {
+public class TextAreaControl extends TextOnlyControl {
 
 	protected final JTextArea textArea;
@@ -39,12 +41,13 @@
 
 	@Override
-	public void pushValueToUserInterfaceImpl(Object value) {
-		textArea.setText((String) value);
-		this.revalidate();
+	protected JTextComponent getTextComponent() {
+		return textArea;
 	}
 
 	@Override
-	public Object pullValueFromUserInterface() {
-		return textArea.getText();
+	public void pushValueToUserInterfaceImpl(Object value) {
+		// getTextComponent().setText(getParam().serialize(value));
+		super.pushValueToUserInterfaceImpl(value);
+		this.revalidate();
 	}
 
Index: /java/main/src/main/java/com/framsticks/gui/controls/TextFieldControl.java
===================================================================
--- /java/main/src/main/java/com/framsticks/gui/controls/TextFieldControl.java	(revision 106)
+++ /java/main/src/main/java/com/framsticks/gui/controls/TextFieldControl.java	(revision 107)
@@ -3,22 +3,23 @@
 import com.framsticks.gui.Gui;
 import com.framsticks.params.PrimitiveParam;
-import com.framsticks.util.lang.Strings;
 
 import javax.swing.*;
+import javax.swing.text.JTextComponent;
+
 import java.awt.*;
 
 @SuppressWarnings("serial")
-public class TextFieldControl extends TextControl {
+public class TextFieldControl extends TextOnlyControl {
 
 
-	private static final Color CORRECT_COLOR = new Color(180, 255, 215);
 	private static final Color WRONG_COLOR = new Color(255, 180, 215);
 
 	protected final JTextField textField;
+	private final Color correctColor;
 
 	@Override
 	protected boolean notifyOfChange() {
 		boolean result = super.notifyOfChange();
-		textField.setBackground(result ? CORRECT_COLOR : WRONG_COLOR);
+		textField.setBackground(result ? correctColor : WRONG_COLOR);
 		return result;
 	}
@@ -28,4 +29,5 @@
 		textField = new JTextField();
 		textField.setName("value");
+		correctColor = textField.getBackground();
 
 		textField.setMinimumSize(new Dimension(0, Control.LINE_HEIGHT));
@@ -37,12 +39,8 @@
 	}
 
-	@Override
-	public void pushValueToUserInterfaceImpl(Object text) {
-		textField.setText(Strings.toStringNullProof(text));
-	}
 
 	@Override
-	public Object pullValueFromUserInterface() {
-		return textField.getText();
+	protected JTextComponent getTextComponent() {
+		return textField;
 	}
 
Index: /java/main/src/main/java/com/framsticks/gui/controls/TextOnlyControl.java
===================================================================
--- /java/main/src/main/java/com/framsticks/gui/controls/TextOnlyControl.java	(revision 107)
+++ /java/main/src/main/java/com/framsticks/gui/controls/TextOnlyControl.java	(revision 107)
@@ -0,0 +1,25 @@
+package com.framsticks.gui.controls;
+
+import javax.swing.text.JTextComponent;
+
+import com.framsticks.params.PrimitiveParam;
+
+@SuppressWarnings("serial")
+public abstract class TextOnlyControl extends TextControl {
+
+	public TextOnlyControl(PrimitiveParam<?> valueParam) {
+		super(valueParam);
+	}
+
+	protected abstract JTextComponent getTextComponent();
+
+	@Override
+	public void pushValueToUserInterfaceImpl(Object text) {
+		getTextComponent().setText(getParam().serialize(text));
+	}
+
+	@Override
+	public Object pullValueFromUserInterface() {
+		return getTextComponent().getText();
+	}
+}
Index: /java/main/src/main/java/com/framsticks/model/Genotype.java
===================================================================
--- /java/main/src/main/java/com/framsticks/model/Genotype.java	(revision 106)
+++ /java/main/src/main/java/com/framsticks/model/Genotype.java	(revision 107)
@@ -112,4 +112,8 @@
 	public void setPopsiz(int popsiz) { this.instances = popsiz; }
 
+	@Override
+	public String toString() {
+		return name;
+	}
 
 }
